Ext.define('DSS.editor.SensorStateEditorPart', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	selectedValue:null,
	grids:{},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },

	getHeight : function() {
		return 0;
	},
	initStores : function () {		
		if (Ext.data.StoreManager.lookup('sensorStateLVL1') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'sensorStateLVL1',
                fields : [ '_id', 'name', 'next', 'icon' ,'passive','sensortype'],
                
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }
		Ext.data.StoreManager.lookup('sensorStateLVL1').removeAll();
		var zones={};
		
		for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++) {
			for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups[0].sensors.length;jIndex++) {
				if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type)>-1) {
					zones['zone' + dss.staticDataModel.nameCache[iIndex].ZoneID]={
						id:dss.staticDataModel.nameCache[iIndex].ZoneID,
						name:dss.staticDataModel.nameCache[iIndex].name
					};
				}
			}
		}
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
			for (var jIndex=0;jIndex<dss.staticDataModel.deviceCache[iIndex].sensors.length;jIndex++) {
				if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(dss.staticDataModel.deviceCache[iIndex].sensors[jIndex].type)>-1) {
					zones['zone' + dss.staticDataModel.deviceCache[iIndex].ZoneID]={
							id:dss.staticDataModel.deviceCache[iIndex].ZoneID,
							name:dss.staticDataModel.getNameForZone(dss.staticDataModel.deviceCache[iIndex].ZoneID)
						};
				}
			}
		}
		
		var oArray=[];
		for (var zKey in zones) 
			if (zones[zKey].id!=0){
				oArray.push({
					_id:zones[zKey].id,
					name:zones[zKey].name,
					next:true,
					icon:null,
					passive:false,
		            sensortype:0
				});
			}
		oArray=oArray.sort(function (s1,s2) {
        	if (s1.name!=s2.name) {
        		if ((s1.name).toUpperCase()<(s2.name).toUpperCase())
        			return -1;
        		if ((s1.name).toUpperCase()>(s2.name).toUpperCase())
        			return 1;
        	}
        	return 0;
		})
		for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++) {
			if (dss.staticDataModel.nameCache[iIndex].ZoneID==0) {
				if (dss.staticDataModel.nameCache[iIndex].groups[0].sensors.length>0) {
					oArray.push({
			            _id : -1,
			            name : '-',
			            passive:true,
			            icon : null,
			            sensortype:0
			        });
					for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups[0].sensors.length;jIndex++) {
						if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type)>-1) { 
							oArray.push({
					            _id : 0,
					            name : dss.staticDataModel.getNameForSensortype(dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type),
					            passive:false,
					            icon : null,
					            sensortype:dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type
					        });

						}
					}
				}
			}
		}
		Ext.data.StoreManager.lookup('sensorStateLVL1').add(oArray);
	},
	selectDeviceSensor:function(dSUID,type) {
		this.selectedValue={stype:'device',dsuid:dSUID,type:type};
		this.sensorSelectorBase.setTitle(_('Reference Sensor'));
		this.sensorValueBase.setDisabled(false);
		var device=dss.staticDataModel.getDevice(dSUID);
		this.sensorSelectedDisplay.setValue(Ext.String.format2(_('Selected: {sensortype} from {devicename} in {zoneofdevice}'),{
			sensortype:dss.staticDataModel.getNameForSensortype(type),
			devicename:device.name,
			zoneofdevice:dss.staticDataModel.getNameForZone(device.ZoneID)
		}));
		this.prepareForType(type);
	},
	selectZoneSensor:function(zone,type) {
		this.selectedValue={stype:'zone',zone:zone,type:type};
		this.sensorSelectorBase.setTitle(_('Reference Sensor'));
		this.sensorValueBase.setDisabled(false);
		this.sensorSelectedDisplay.setValue(Ext.String.format2(_('Selected: {sensortype} for room {zonename}'),{
			sensortype:dss.staticDataModel.getNameForSensortype(type),
			zonename:dss.staticDataModel.getNameForZone(zone)
		}));
		this.prepareForType(type);
	},
	prepareForType:function(type) {

		this.sensorSelectedComparator.setValue('>');
		this.sensorSelectedResetBefore.setValue({
			'sensorSelectedResetType':'0'
		});

		switch (type) {
		case 9:
		case 10: // temperature -43,15   - 58,85
			this.sensorSelectedValueLB.update('<span style="color:#005138">&deg;C</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">&deg;C</span>');
			this.sensorSelectedReset.setMinValue(-43.2);
			this.sensorSelectedValue.setMinValue(-43.2);
			this.sensorSelectedReset.setMaxValue(58.8);
			this.sensorSelectedValue.setMaxValue(58.8);
			this.sensorSelectedReset.setValue(21);
			this.sensorSelectedValue.setValue(21);
			break;
		case 11: // brightness Lx  0 -  131446
		case 12: // brightness Lx  0 -  131446
			this.sensorSelectedValueLB.update('<span style="color:#005138">Lx</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">Lx</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(131446);
			this.sensorSelectedValue.setMaxValue(131446);
			this.sensorSelectedReset.setValue(150);
			this.sensorSelectedValue.setValue(150);
		break;
		case 13: //humidity % 0-100 
		case 14: 			
			this.sensorSelectedValueLB.update('<span style="color:#005138">%</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">%</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(100);
			this.sensorSelectedValue.setMaxValue(100);
			this.sensorSelectedReset.setValue(50);
			this.sensorSelectedValue.setValue(50);
		break;
		case 15: // druck: hPa 200-1223
			this.sensorSelectedValueLB.update('<span style="color:#005138">hPa</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">hPa</span>');
			this.sensorSelectedReset.setMinValue(200);
			this.sensorSelectedValue.setMinValue(200);
			this.sensorSelectedReset.setMaxValue(1223);
			this.sensorSelectedValue.setMaxValue(1223);
			this.sensorSelectedReset.setValue(1000);
			this.sensorSelectedValue.setValue(1000);
		break;
		case 18: // wind-geschwi m/s : 0 - 102 
			this.sensorSelectedValueLB.update('<span style="color:#005138">m/s</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">m/s</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(102);
			this.sensorSelectedValue.setMaxValue(102);
			this.sensorSelectedReset.setValue(6);
			this.sensorSelectedValue.setValue(6);
		break
		case 19:  // windrichtung (&deg;) 0-359
			this.sensorSelectedValueLB.update('<span style="color:#005138">%deg;</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">&deg;</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(359);
			this.sensorSelectedValue.setMaxValue(359);
			this.sensorSelectedReset.setValue(0);
			this.sensorSelectedValue.setValue(0);
		break;
		case 20: // niederschlag mm/m2 0 - 102
			this.sensorSelectedValueLB.update('<span style="color:#005138">mm/m&sup2;</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">mm/m&sup2;</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(102);
			this.sensorSelectedValue.setMaxValue(102);
			this.sensorSelectedReset.setValue(1);
			this.sensorSelectedValue.setValue(1);

		break;
		case 21: //co2 ppm 1 - 131446
			this.sensorSelectedValueLB.update('<span style="color:#005138">ppm</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">ppm</span>');
			this.sensorSelectedReset.setMinValue(1);
			this.sensorSelectedValue.setMinValue(1);
			this.sensorSelectedReset.setMaxValue(131446);
			this.sensorSelectedValue.setMaxValue(131446);
			this.sensorSelectedReset.setValue(1000);
			this.sensorSelectedValue.setValue(1000);

		break;
		case 25: // sound dB 0 - 255
			this.sensorSelectedValueLB.update('<span style="color:#005138">dB</span>');
			this.sensorSelectedResetLB.update('<span style="color:#005138">dB</span>');
			this.sensorSelectedReset.setMinValue(0);
			this.sensorSelectedValue.setMinValue(0);
			this.sensorSelectedReset.setMaxValue(255);
			this.sensorSelectedValue.setMaxValue(255);
			this.sensorSelectedReset.setValue(60);
			this.sensorSelectedValue.setValue(60);

		break;
		}
	},
	tempSel:null,
	constructGridLvlDevice:function(dSUID) {
		this.tempSel=dSUID;
		if (Ext.data.StoreManager.lookup('sensorStateDevice') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'sensorStateDevice',
                fields : [ '_id', 'name', 'next', 'passive', 'icon','sensortype' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
    	}
    	Ext.data.StoreManager.lookup('sensorStateDevice').removeAll();
    	var oDevice=dss.staticDataModel.getDevice(dSUID);
    	for (var iIndex=0;iIndex<oDevice.sensors.length;iIndex++) {
    		if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(oDevice.sensors[iIndex].type)>-1) {
				Ext.data.StoreManager.lookup('sensorStateDevice').add({
	                name : dss.staticDataModel.getNameForSensortype(oDevice.sensors[iIndex].type),
	                _id : 0,
	                next : false,
	                icon : null,
	                passive:false,
	                sensortype:oDevice.sensors[iIndex].type
	            });    			
    		}
    	}
    	
    	this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
		    hideHeaders:true,
		    height : 216,
		    width : 246,
		    autoScroll : true,
		    viewConfig : {
		        stripeRows : true
		    },
		    selModel : {
		        mode : 'MULTI'
		    },
		    store : Ext.data.StoreManager.lookup('sensorStateDevice'),
		    columns : [ {
		        sortable : false,
		        hideable : false,
		        text : _('state'),
		        dataIndex : 'name',
		        flex : 1,
		        renderer : this.defMacGridRenderer
		    } ]
		});
		
		this.grids.lvlDevice.parent = this;
		
		this.grids.lvlDevice.on('beforeitemclick', function(grid, record) {
		    if (record.get('passive')!=null) 
		        if (record.get('passive')==true)
		        	return false;
		    return true;
		});
		
		this.grids.lvlDevice.on('itemclick', function(grid, record) {
			this.parent.sensorValueBase.setDisabled(true);
		    this.getSelectionModel().deselectAll();
		    this.getSelectionModel().select(record);
		    this.parent.selectedValue=null;
		    this.parent.selectDeviceSensor(this.parent.tempSel,record.get('sensortype'));
		});
		
		this.macPanel.add(this.grids.lvlDevice);
	},
	constructGridLvlRoom: function (ZoneID) {
		this.tempSel=ZoneID;
		 
		if (Ext.data.StoreManager.lookup('sensorStateRoom') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'sensorStateRoom',
                fields : [ '_id', 'name', 'next', 'passive', 'icon','sensortype','zoneID' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
    	}
    	Ext.data.StoreManager.lookup('sensorStateRoom').removeAll();
    		
		for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++) 
			if (dss.staticDataModel.nameCache[iIndex].ZoneID==ZoneID) {
				for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups[0].sensors.length;jIndex++) {
						if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type)>-1) {
								Ext.data.StoreManager.lookup('sensorStateRoom').add({
					                name : dss.staticDataModel.getNameForSensortype(dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type),
					                _id : 0,
					                zoneID:ZoneID,
					                next : false,
					                icon : null,
					                passive:false,
					                sensortype:dss.staticDataModel.nameCache[iIndex].groups[0].sensors[jIndex].type
					            });
						}
				}
			}	
    	var fFirst=true;
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
			if (dss.staticDataModel.deviceCache[iIndex].ZoneID==ZoneID) {
				var fAdded=false;
				for (var jIndex=0;jIndex<dss.staticDataModel.deviceCache[iIndex].sensors.length;jIndex++) {
					if ([9,10,11,12,13,14,15,18,19,20,21,25].indexOf(dss.staticDataModel.deviceCache[iIndex].sensors[jIndex].type)>-1) {
						if (fFirst) {
							Ext.data.StoreManager.lookup('sensorStateRoom').add({
					            _id : -1,
					            name : '-',
					            zoneID:-1,
					            passive:true,
					            icon : null,
					            sensortype:0
					        });
						}
						fFirst=false;

						if (!fAdded)
							Ext.data.StoreManager.lookup('sensorStateRoom').add({
								_id:dss.staticDataModel.deviceCache[iIndex].dSUID,
								name:dss.staticDataModel.getDevice(dss.staticDataModel.deviceCache[iIndex].dSUID).name,
								next:true,
								zoneID:-1,
								icon:dss.staticDataModel.getDevice(dss.staticDataModel.deviceCache[iIndex].dSUID).icon,
								passive:false,
					            sensortype:0
							});
						fAdded=true;
					}
				}
			}
		}
		
		this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 216,
            width : 244,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('sensorStateRoom'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlRoom.parent = this;

        this.grids.lvlRoom.on('beforeitemclick', function(grid, record) {
            if (record.get('passive')!=null) 
                if (record.get('passive')==true)
                	return false;
            return true;
        });
        
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
        	this.parent.sensorValueBase.setDisabled(true);
        	this.parent.selectedValue=null;
        	this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.getSelectionModel().deselectAll();
            if (record.get('_id')==-1) {
            	return;
            }
            this.getSelectionModel().select(record);
            if (record.get('_id')==0) {
            	this.parent.selectZoneSensor(record.get('zoneID'),record.get('sensortype'));
            	return;
            }
            this.parent.constructGridLvlDevice(record.get('_id'));           
        });
        
        this.macPanel.add(this.grids.lvlRoom);
	        
	},
	constructLVL1: function () {
		var lvl1Store;
    	if (this.grids.lvl1==null) {
	        var lvl1TempStore = Ext.create('Ext.data.Store', {
	            fields : [  '_id', 'name', 'next', 'icon' ,'passive','sensortype' ],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            }
	        });
	
	        lvl1Store = Ext.data.StoreManager.lookup('sensorStateLVL1');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            lvl1TempStore.add(oNewRecord);
	        });
	        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            hideHeaders:true,
	            height : 216,
	            width : 244,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            selModel : {
	                mode : 'MULTI'
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                text : _('Action'),
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
	        this.grids.lvl1.parent = this;
	        this.grids.lvl1.on('beforeitemclick', function(grid, record) {
	            if (record.get('passive')!=null) 
	                if (record.get('passive')==true)
	                	return false;
	            return true;
	        });
	        
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	        	this.parent.sensorValueBase.setDisabled(true);
	        	this.parent.selectedValue=null;
                var fIsPassive=false;
	            if (record.get('passive')!=null) {
	                if (record.get('passive')==true) {
	                	this.getSelectionModel().deselectAll();
	                    return;
	                }
	            }
	            if (record.get('_id')==0) {
    	        	this.parent.macPanel.remove(this.parent.grids.lvlRoom);
    	        	this.parent.macPanel.remove(this.parent.grids.lvlDevice);
	            	this.parent.selectZoneSensor(0,record.get('sensortype'));
	            }
                if (record.get('_id') > 0) { // zone states
    	        	this.parent.macPanel.remove(this.parent.grids.lvlRoom);
    	        	this.parent.macPanel.remove(this.parent.grids.lvlDevice);
                    this.getSelectionModel().deselectAll();
                    this.getSelectionModel().select(record);
                    this.parent.constructGridLvlRoom(record.get('_id'));
                } 
	            this.parent.macPanel.doLayout();
	        }); 
	        this.macPanel.add(this.grids.lvl1);
    	} else {
    		
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;        	
	        lvl1Store = Ext.data.StoreManager.lookup('sensorStateLVL1');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            mThis.grids.lvl1.getStore().add(oNewRecord);
	        });
        	this.macPanel.remove(this.grids.lvlRoom);
        	this.macPanel.remove(this.grids.lvlDevice);        	
    	}

	},
	setMinMax: function () {
		var minValue=this.sensorSelectedValue.minValue;
		var maxValue=this.sensorSelectedValue.maxValue;
		if (this.sensorSelectedResetBefore.getValue().sensorSelectedResetType!='0') {
			if (this.sensorSelectedComparator.getValue()=='>') {
				maxValue=this.sensorSelectedValue.getValue();
			} else {
				minValue=this.sensorSelectedValue.getValue();
			}
		}
		this.sensorSelectedReset.setMinValue(minValue);
		this.sensorSelectedReset.setMaxValue(maxValue);
		if (this.sensorSelectedResetBefore.getValue().sensorSelectedResetType!='0') {
			if (this.sensorSelectedReset.getValue()<minValue)
				this.sensorSelectedReset.setValue(minValue);
			if (this.sensorSelectedReset.getValue()>maxValue)
				this.sensorSelectedReset.setValue(maxValue);
		} else {
			this.sensorSelectedReset.setValue(null);
		}
	},
	constructor : function(config) {		
		var me=this;
    	this.initStores();
		this.grids={};
    	
		this.macPanel=Ext.create('Ext.panel.Panel', {		
			border : '0',
			title:' ',
            header:false,
			items : [  ],
			height: 218,
			width:736,
			autoScroll : true,
	        layout : {
	            type : 'hbox'
	        },
        	scroll : 'horizontal'        	
		});

    	
		this.sensorSelectorBase=Ext.create('Ext.panel.Panel', {		
			title: _('Reference Sensor'),
			items : [Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                value:_('Please select the reference sensor value or device'),
                width:770,
                margin: "7 0 10 5",
                style: {
                    fontSize: '11px'
                }
            }), this.macPanel],
			height: 280,
			width:738,
			layout: {
				type: 'vbox'
			}
		});
		this.sensorSelectedDisplay=Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:_('Device XY'),
            width:770,
            margin: "7 0 10 5",
            style: {
                fontSize: '11px'
            },
            colspan:3
        });
		this.sensorSelectedComparator=Ext.create("DSS.component.ComboboxControl",{
			data:[{label:_('greater than'),value:'>'},
			      {label:_('lesser than'),value:'<'}],
			storevalueid:'value',
			storedisplayid:'label',
			labelWidth:190,
			margin: "10 0 10 5",
			label:_('Set state if value is'),
			width : 290,
			border:0
		});
		this.sensorSelectedComparator.cboCombo.on('change',function (oThis,newValue) {
			if (newValue=='>') {
				me.sensorSelectedResetBeforeRB1.boxLabelEl.update('<span style="color:#005138">' + _('Reset state if value is lower than set value') + '</span>');
				me.sensorSelectedResetBeforeRB2.boxLabelEl.update('<span style="color:#005138">' + _('Reset state if value is lower than') + '</span>');
			} else {
				me.sensorSelectedResetBeforeRB1.boxLabelEl.update('<span style="color:#005138">' + _('Reset state if value is greater than set value') + '</span>');
				me.sensorSelectedResetBeforeRB2.boxLabelEl.update('<span style="color:#005138">' + _('Reset state if value is greater than') + '</span>');				
			}
			me.setMinMax();
		});
		
		this.sensorSelectedComparator.cboCombo.setWidth(290);
		this.sensorSelectedValue=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 70,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 100,
            autoStripChars:true,
            decimalPrecision:1,
            decimalSeparator:','
        });				
		this.sensorSelectedValue.on('change',function() {
			me.setMinMax();
		})
		this.sensorSelectedValueLB = Ext.create('Ext.panel.Panel', {
			margin : '6 0 0 5',
			border : false,
			html : '<span style="color:#005138">&deg;C</span>',
			width : 400,
			height: 28
		});
		
		this.sensorSelectedResetBeforeRB1=Ext.create('Ext.form.field.Radio', {
			boxLabel:'<span style="color:#005138">' + _('Reset state if value is lower than set value') + '</span>',
			name:'sensorSelectedResetType',
			inputValue:'0'
		});
		
		this.sensorSelectedResetBeforeRB2=Ext.create('Ext.form.field.Radio', {
			boxLabel:'<span style="color:#005138">' + _('Reset state if value is lower than') + '</span>',
			name:'sensorSelectedResetType',
			inputValue:'1'
		});
		
		this.sensorSelectedResetBefore=Ext.create('Ext.form.RadioGroup', {
			columns:1,
			width: 300,
			margin: "7 0 10 5",
			items:[this.sensorSelectedResetBeforeRB1,this.sensorSelectedResetBeforeRB2]
		});
		this.sensorSelectedResetBefore.on('change',function (oThis,newValue) {
			if (newValue.sensorSelectedResetType!=null) {
				me.sensorSelectedReset.setDisabled(newValue.sensorSelectedResetType=='0');
				me.setMinMax();
			}
		});
		
		
		this.sensorSelectedReset=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 70,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 100,
            margin: "19 0 0 0",
            autoStripChars:true,
            decimalPrecision:1,
            decimalSeparator:','
        });
		this.sensorSelectedResetLB = Ext.create('Ext.panel.Panel', {
			padding : '18 0 0 5',
			border : false,
			html : '<span style="color:#005138">&deg;C</span>',
			width : 400
		});

		this.sensorValueBase=Ext.create('Ext.panel.Panel', {
			title: _('Value to set/reset the state'),
			items : [  Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                value:_('Please define the conditions and values to set and reset this state'),
                width:770,
                margin: "7 0 10 5",
                style: {
                    fontSize: '11px'
                },
                colspan:3
            }), this.sensorSelectedDisplay,
            this.sensorSelectedComparator,this.sensorSelectedValue,this.sensorSelectedValueLB,
            this.sensorSelectedResetBefore,this.sensorSelectedReset,this.sensorSelectedResetLB],
			height: 280,
			width:738,
			layout: {
				type:'table',
    			columns:3
			}
		});
  
		this.baseTab=Ext.create('Ext.tab.Panel', {
        	border: 0,
			height: 280,
            cls:'generalTab',
            items : [ this.sensorSelectorBase,
                      this.sensorValueBase]
        });
		
        Ext.apply(this, {
        	border: 0,
  			items : [ this.baseTab ],
  			height: 300,
  			width:740,
  			layout: {
  				type: 'hbox'
  			}
  		});
  	
  		this.callParent(arguments);
	},
	reset : function() {
		this.selectedValue=null;
		this.initStores();
  		this.constructLVL1();
		this.sensorValueBase.setDisabled(true);
		this.baseTab.setActiveTab(1);
		this.baseTab.setActiveTab(0);
		this.sensorSelectorBase.setTitle(_('Reference Sensor'));
	},	
	isValid : function() {
		if (this.isHidden())
			return true;
		
		if (this.selectedValue==null) {
			this.sensorSelectorBase.setTitle('<span style="color:#ff0000;">' + _('Reference Sensor') + '</span>');
			return false;
		} else 
			this.sensorSelectorBase.setTitle(_('Reference Sensor'))
		if (this.sensorSelectedResetBefore.getValue().sensorSelectedResetType!='0')
			if (this.sensorSelectedComparator.getValue()=='>') {
				if (this.sensorSelectedValue.getValue()<this.sensorSelectedReset.getValue())
					return false;
			} else {
				if (this.sensorSelectedValue.getValue()>this.sensorSelectedReset.getValue())
					return false;
			}
		return true;
	},
	setValue : function(oValue) {
		this.reset();
		if (oValue.zone!=null) {
			
			if (oValue.zone.zoneID==0) {
				var oRecordZone=this.grids.lvl1.store.find('sensortype',oValue.zone.typeID,0,false,false,true);
		        if (oRecordZone != -1) {
		            this.grids.lvl1.getSelectionModel().select(oRecordZone,true);
		            
		            this.selectZoneSensor(0,record.get('sensortype'));
		        }
			} else {
				var oRecordZone=this.grids.lvl1.store.find('_id',oValue.zone.zoneID,0,false,false,true);
		        if (oRecordZone != -1) {
		            this.grids.lvl1.getSelectionModel().select(oRecordZone,true);
		            this.constructGridLvlRoom(oValue.zone.zoneID);
		            var oRecordType=this.grids.lvlRoom.store.find('sensortype',oValue.zone.typeID,0,false,false,true);
		            if (oRecordType!=-1) {
		            	this.grids.lvlRoom.getSelectionModel().select(oRecordType,true);
		            	this.selectZoneSensor(oValue.zone.zoneID,oValue.zone.typeID);
		            }		            
		        }		        
			}
			if (oValue.zone.greaterOnSet) {
				this.sensorSelectedComparator.setValue('>');
			} else {
				this.sensorSelectedComparator.setValue('<');
			}
			if (oValue.zone.activeValue!=oValue.zone.inactiveValue) {
				this.sensorSelectedResetBefore.setValue({sensorSelectedResetType:'1'});
			} else {
				this.sensorSelectedResetBefore.setValue({sensorSelectedResetType:'0'});
			}
			this.sensorSelectedValue.setValue(oValue.zone.activeValue);
			this.sensorSelectedReset.setValue(oValue.zone.inactiveValue);
		} 
		if (oValue.device!=null) {
			var oDevice=dss.staticDataModel.getDevice(oValue.device.dsid);
			var oRecordZone=this.grids.lvl1.store.find('_id',oDevice.ZoneID,0,false,false,true);
	        if (oRecordZone != -1) {
	            this.grids.lvl1.getSelectionModel().select(oRecordZone,true);
	            this.constructGridLvlRoom(oDevice.ZoneID);
	            var oRecordType=this.grids.lvlRoom.store.find('_id',oValue.device.dsid,0,false,false,true);
	            if (oRecordType!=-1) {
	            	this.grids.lvlRoom.getSelectionModel().select(oRecordType,true);
	            	this.constructGridLvlDevice(oValue.device.dsid);
	            	
		            var oRecordDevice=this.grids.lvlDevice.store.find('sensortype',oValue.device.typeID,0,false,false,true);
	            	if (oRecordDevice!=-1) {
	            		this.grids.lvlDevice.getSelectionModel().select(oRecordDevice,true);
	            		this.selectDeviceSensor(oValue.device.dsid,oValue.device.typeID);
	            	}
	            }		            
	        }	
			
			if (oValue.device.greaterOnSet) {
				this.sensorSelectedComparator.setValue('>');
			} else {
				this.sensorSelectedComparator.setValue('<');
			}
			if (oValue.device.activeValue!=oValue.device.inactiveValue) {
				this.sensorSelectedResetBefore.setValue({sensorSelectedResetType:'1'});
			} else {
				this.sensorSelectedResetBefore.setValue({sensorSelectedResetType:'0'});
			}
			this.sensorSelectedValue.setValue(oValue.device.activeValue);
			this.sensorSelectedReset.setValue(oValue.device.inactiveValue);
		}
	},
	
	getValue : function() {
		if (this.isHidden())
			return {};
		
		var oObject={};
		if (this.selectedValue.stype=='device') {
			this.dssEditor.editControls['type'].setValue('device-sensor-states');
			oObject.device={
				greaterOnSet:(this.sensorSelectedComparator.getValue()=='>'),				
				activeValue:this.sensorSelectedValue.getValue(),
				dsid:this.selectedValue.dsuid,
				typeID:this.selectedValue.type
			};
			if (this.sensorSelectedResetBefore.getValue().sensorSelectedResetType=='0')
				oObject.device.inactiveValue=this.sensorSelectedValue.getValue();
			else
				oObject.device.inactiveValue=this.sensorSelectedReset.getValue();
		} else {
			this.dssEditor.editControls['type'].setValue('zone-sensor-states');
			oObject.zone={
					greaterOnSet:(this.sensorSelectedComparator.getValue()=='>'),				
					activeValue:this.sensorSelectedValue.getValue(),
					zoneID:this.selectedValue.zone,
					groupID:0,
					typeID:this.selectedValue.type
				};
				if (this.sensorSelectedResetBefore.getValue().sensorSelectedResetType=='0')
					oObject.zone.inactiveValue=this.sensorSelectedValue.getValue();
				else
					oObject.zone.inactiveValue=this.sensorSelectedReset.getValue();
		}
		return oObject;
	}
});