Ext.define('DSS.editor.StarterEditorPart', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },
	getHeight : function() {
		return 400;
	},
	myType:null,
	isWindowAvaible: function () {
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
        	var oDevice=dss.staticDataModel.deviceCache[iIndex];        	
        	if (oDevice.present) {    			
	    		if (dss.staticDataModel.IsWindowHandle(oDevice))
	    			return true;
	    		if (oDevice.binaryInputs!=null)
	    			if (oDevice.binaryInputs.length==1)
	    				if (oDevice.binaryInputs[0].type==14) {
	    					return true;
	    				}
        	}
        }		
		
		return false;
	},
	isConsumptionAvaible: function () {
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
			if (dss.staticDataModel.deviceCache[iIndex].HWInfo.indexOf("SW-ZWS")>-1)
				return true;
		}
		return false;
	},
	isDSMPowerAvaible: function () {
		for (var iIndex=0;iIndex<dss.staticDataModel.MeterCache.length;iIndex++) {
			for (var jIndex=0;jIndex<dss.staticDataModel.MeterCache[iIndex].capabilities.length;jIndex++)
				if (dss.staticDataModel.MeterCache[iIndex].capabilities[jIndex].metering)
					return true;
		}
		return false;
	},
	isSensorAvaible:function() {
		if (dss.staticDataModel.deviceWithSensorsCache.length>0)
			return true;
		for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++)
			for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups.length;jIndex++)
				if (dss.staticDataModel.nameCache[iIndex].groups[jIndex].sensors.length>0)
					return true;
		return false;
	},
	initStore: function() {
		if (Ext.data.StoreManager.lookup('starterState') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'starterState',
                fields : [ '_id', 'name', 'next', 'icon','passive' ],
                
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });        
		}
		Ext.data.StoreManager.lookup('starterState').removeAll();
		var oArray=[];
		
		Ext.data.StoreManager.lookup('starterState').add(
				[
				 {name:_('Use sensor value'),_id:'zone-sensor-states',next:true,icon:null,passive:!this.isSensorAvaible()},
				 {name:_('Check whether any window is open'),_id:'window-states',next:true,icon:null,passive:!this.isWindowAvaible()},
				 {name:_('Define a consumption message state'),_id:'consumption-states',next:true,icon:null,passive:!this.isConsumptionAvaible()},
			     {name:_('Use dSM Power Consumption'),_id:'power-states',next:true,icon:null,passive:!this.isDSMPowerAvaible()},
			     {name:_('Use system triggers to set state'),_id:'triggered-states',next:true,icon:null},		        		        
		         {name:_('Use a binary logic to evaluate the state'),_id:'combined-states',next:true,icon:null},
				 {name:_('I will set the state manually'),_id:'custom-states',next:true,icon:null}
		        ]);
	},
	typeSelection : function (selected) {
		if (selected=="") {
			this.reset();
			return;
		}
		this.wzWindow.setVisible(false);
		this.wzConsumption.setVisible(false);
		this.wzManually.setVisible(false);
		this.wzSensor.setVisible(false);
		this.wzdSM.setVisible(false);
		this.wzSystemtrigger.setVisible(false);
		this.wzCombined.setVisible(false);
		this.wzPower.setVisible(false);
		this.myType=selected;
		switch (selected) {
			case 'window-states':
				this.wzWindow.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'consumption-states':
				this.wzConsumption.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'custom-states':
				this.wzManually.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'zone-sensor-states':
			case 'device-sensor-states':
				this.wzSensor.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'power-states':
				this.wzdSM.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'triggered-states':
				this.wzSystemtrigger.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'combined-states':
				this.wzCombined.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			case 'power-states':
				this.wzPower.setVisible(true);
		        this.nextButton.setDisabled(false);
			break;
			
		}
	},
	constructor : function(config) {
		this.wzWindow=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/window.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzConsumption=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/consumption.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzManually=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/manually.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzSensor=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/sensor.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzdSM=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/dSM.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzSystemtrigger=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/triggered.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzCombined=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/combined.html',
                autoLoad : true,
                disableCaching : false
            }
        });
		this.wzPower=Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            hidden:true,
            loader : {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/power.html',
                autoLoad : true,
                disableCaching : false
            }
        });

		var me=this;
		this.initStore();
		this.selectGrid = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 250,
            width : 300,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('starterState'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('Action'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
	    this.selectGrid.on('selectionchange', function(grid, selections) {
	    	if (selections.length==1) {
	    		var record=selections[0];
	            if (record.get('passive')!=null)
	            	if (record.get('passive')==true) {
	            		this.getSelectionModel().deselectAll();
	    	            me.typeSelection("");
	            		return;
	            	}
	            //this.getSelectionModel().select(record);
	        	me.typeSelection(record.get('_id'));
	    	}
        });
	    
	    this.descriptionField=Ext.create('Ext.panel.Panel',{
			height:250,
			width:430,
			border:1,
			items:[
				this.wzWindow,
				this.wzConsumption,
				this.wzManually,
				this.wzSensor,
				this.wzdSM,
				this.wzSystemtrigger,
				this.wzCombined
			]
		});
		/*this.advancedCheckbox=Ext.create('Ext.form.field.Checkbox',{
			boxLabel:_('Use advanced features')
		});*/
		Ext.apply(this, {
        	border: 0,
  			items : [Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                colspan:2,
                value:_('This wizard will guide though the required steps to setting up a new state.'),
                width:700,
                margin: "7 0 10 5",
                style: {
                    fontSize: '11px'
                }
            }), Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                colspan:2,
                value:_('Please choose what kind of state you like to create.'),
                width:700,
                margin: "7 0 10 5",
                style: {
                    fontSize: '11px'
                }
            }), 
            this.selectGrid,this.descriptionField],
  			height: 360,
  			width:740,
  			layout: {
  				type: 'table',
  				columns:2
  			}
  		});
		this.nextButton= Ext.create('Ext.Button', {
            text : _('Next'),
            handler : function() {
            	me.nextFunction();
            }
        });
  		this.callParent(arguments);
	},
	nextFunction: function() {
		if (this.myType==null)
			return;
		this.setVisible(false);
		this.nextButton.setVisible(false);
        this.dssEditor.buttonSave.setVisible(true);
		this.dssEditor.editControls['activityState'].setVisible(false);
		this.dssEditor.editControls['combinedState'].setVisible(false);
		this.dssEditor.editControls['sensorState'].setVisible(false);
		this.dssEditor.editControls['consumptionState'].setVisible(false);
		this.dssEditor.editControls['powerState'].setVisible(false);
		this.dssEditor.editControls['windowState'].setVisible(false);
		this.dssEditor.editControls['combinedNames'].setVisible(true);
		this.dssEditor.editControls['combinedNames'].operationSelector.setVisible(false);
		this.dssEditor.editControls['combinedNames'].placeholder.setVisible(true);
		//me.dssEditor.setHeight(170);
		switch (this.myType) {
			case 'custom-states':
				this.dssEditor.setHeight(170);
			break;
			case 'triggered-states': 
				this.dssEditor.editControls['activityState'].setVisible(true);
				this.dssEditor.setHeight(530);
			break;
			case 'combined-states':
				this.dssEditor.editControls['combinedState'].setVisible(true);
				this.dssEditor.editControls['combinedNames'].operationSelector.setVisible(true);
				this.dssEditor.editControls['combinedNames'].placeholder.setVisible(false);
				this.dssEditor.setHeight(470);
			break;
			case 'zone-sensor-states':
			case 'device-sensor-states':
				this.dssEditor.editControls['sensorState'].setVisible(true);
				this.dssEditor.setHeight(470);
			break;
			case 'consumption-states':
				this.dssEditor.editControls['consumptionState'].setVisible(true);
				this.dssEditor.setHeight(470);
			break;
			case 'window-states':
				this.dssEditor.editControls['windowState'].setVisible(true);
				this.dssEditor.setHeight(470);
			break;
			case 'power-states':
				this.dssEditor.editControls['powerState'].setVisible(true);
				this.dssEditor.setHeight(420);
			break;
		}
	},
	reset : function() {
		this.myType=null;		
        var oTB=this.dssEditor.items.items[0].getDockedItems('toolbar[dock="bottom"]')[0];
        if (oTB.items.items.length==3) {
        	oTB.insert(1,this.nextButton);
        }
        this.nextButton.setDisabled(true);
        this.nextButton.setVisible(true);
        this.dssEditor.editControls['combinedNames'].operationSelector.setVisible(false);
		this.dssEditor.editControls['combinedNames'].placeholder.setVisible(true);

        this.dssEditor.buttonSave.setVisible(false);
		this.dssEditor.setHeight(470);
		this.selectGrid.getSelectionModel().deselectAll();
		this.setVisible(true);
		if (this.dssEditor.editControls['combinedNames']!=null)
			this.dssEditor.editControls['combinedNames'].setVisible(false);
		if (this.dssEditor.editControls['activityState']!=null)
			this.dssEditor.editControls['activityState'].setVisible(false);
		if (this.dssEditor.editControls['combinedState']!=null)
			this.dssEditor.editControls['combinedState'].setVisible(false);
		if (this.dssEditor.editControls['sensorState']!=null)
			this.dssEditor.editControls['sensorState'].setVisible(false);
		if (this.dssEditor.editControls['consumptionState']!=null)
			this.dssEditor.editControls['consumptionState'].setVisible(false);
		if (this.dssEditor.editControls['windowState']!=null)
			this.dssEditor.editControls['windowState'].setVisible(false);
		if (this.dssEditor.editControls['powerState']!=null)
			this.dssEditor.editControls['powerState'].setVisible(false);
		
		var oRecord=this.selectGrid.store.find('_id',"zone-sensor-states",0,false,false,true);
        if (oRecord != -1) {
        	this.selectGrid.getSelectionModel().select(oRecord,true);
        }
	},
	isValid : function() {
		if (this.isHidden())
			return true;
		if (this.myType==null)
			return false;
		return true;
	},
	setValue : function(oValue) {
		if (oValue==null)
			this.reset(); 
		else {
			this.myType=oValue;
			this.nextFunction();
		}
	},
	getValue : function() {
		return this.myType;
	}
});